clear all;
clc;
load mushroom_cellnew.mat;
mushroom_num = E;

% get size of dataset
[mushroom_row,mushroom_column] = size(mushroom_num);

% 4 way cross validation
mushroom1 = mushroom_num(1:mushroom_row/4,:);
mushroom2 = mushroom_num(mushroom_row/4 + 1:2*mushroom_row/4,:);
mushroom3 = mushroom_num(2*mushroom_row/4 + 1:3*mushroom_row/4,:);
mushroom4 = mushroom_num(3*mushroom_row/4 + 1:mushroom_row,:);

% dataset 1
mushroom_train4 = [mushroom2;mushroom3;mushroom4];
mushroom_test4 = mushroom1;

% size in loop
trainsize = 3*mushroom_row/4;
testsize = mushroom_row/4;

% initialize a matrix to store final edibility
FED = zeros(testsize,1);

% variables for classification rate
rt = 0;
cr = 0;

% get probability
yesb1 = 0;
yesc1 = 0;
yesx1 = 0;
yesf1 = 0;
yesk1 = 0;
yess1 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,1) == char('b')
            yesb1 = yesb1 + 1;
        elseif mushroom_train4(i,1) == char('c')
            yesc1 = yesc1 + 1;
        elseif mushroom_train4(i,1) == char('x')
            yesx1 = yesx1 + 1;
        elseif mushroom_train4(i,1) == char('f')
            yesf1 = yesf1 + 1;
        elseif mushroom_train4(i,1) == char('k')
            yesk1 = yesk1 + 1;
        elseif mushroom_train4(i,1) == char('s')
            yess1 = yess1 + 1;
        end
    end
end
pb1 = yesb1/sum(mushroom_train4(:,1) == char('b'));
pc1 = yesc1/sum(mushroom_train4(:,1) == char('c'));
px1 = yesx1/sum(mushroom_train4(:,1) == char('x'));
pf1 = yesf1/sum(mushroom_train4(:,1) == char('f'));
pk1 = yesk1/sum(mushroom_train4(:,1) == char('k'));
ps1 = yess1/sum(mushroom_train4(:,1) == char('s'));

yesf2 = 0;
yesg2 = 0;
yesy2 = 0;
yess2 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,2) == char('f')
            yesf2 = yesf2 + 1;
        elseif mushroom_train4(i,2) == char('g')
            yesg2 = yesg2 + 1;
        elseif mushroom_train4(i,2) == char('y')
            yesy2 = yesy2 + 1;
        elseif mushroom_train4(i,2) == char('s')
            yess2 = yess2 + 1;
        end
    end
end
pf2 = yesf2/sum(mushroom_train4(:,2) == char('f'));
pg2 = yesg2/sum(mushroom_train4(:,2) == char('g'));
py2 = yesy2/sum(mushroom_train4(:,2) == char('y'));
ps2 = yess2/sum(mushroom_train4(:,2) == char('s'));

yesn3 = 0;
yesb3 = 0;
yesc3 = 0;
yesg3 = 0;
yesr3 = 0;
yesp3 = 0;
yesu3 = 0;
yese3 = 0;
yesw3 = 0;
yesy3 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,3) == char('n')
            yesn3 = yesn3 + 1;
        elseif mushroom_train4(i,3) == char('b')
            yesb3 = yesb3 + 1;
        elseif mushroom_train4(i,3) == char('c')
            yesc3 = yesc3 + 1;
        elseif mushroom_train4(i,3) == char('g')
            yesg3 = yesg3 + 1;
        elseif mushroom_train4(i,3) == char('r')
            yesr3 = yesr3 + 1;
        elseif mushroom_train4(i,3) == char('p')
            yesp3 = yesp3 + 1;
        elseif mushroom_train4(i,3) == char('u')
            yesu3 = yesu3 + 1;
        elseif mushroom_train4(i,3) == char('e')
            yese3 = yese3 + 1;
        elseif mushroom_train4(i,3) == char('w')
            yesw3 = yesw3 + 1;
        elseif mushroom_train4(i,3) == char('y')
            yesy3 = yesy3 + 1;
        end
    end
end
pn3 = yesn3/sum(mushroom_train4(:,3) == char('n'));
pb3 = yesb3/sum(mushroom_train4(:,3) == char('b'));
pc3 = yesc3/sum(mushroom_train4(:,3) == char('c'));
pg3 = yesg3/sum(mushroom_train4(:,3) == char('g'));
pr3 = yesr3/sum(mushroom_train4(:,3) == char('r'));
pp3 = yesp3/sum(mushroom_train4(:,3) == char('p'));
pu3 = yesu3/sum(mushroom_train4(:,3) == char('u'));
pe3 = yese3/sum(mushroom_train4(:,3) == char('e'));
pw3 = yesw3/sum(mushroom_train4(:,3) == char('w'));
py3 = yesy3/sum(mushroom_train4(:,3) == char('y'));

yest4 = 0;
yesf4 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,4) == char('t')
            yest4 = yest4 + 1;
        elseif mushroom_train4(i,4) == char('f')
            yesf4 = yesf4 + 1;
        end
    end
end
pt4 = yest4/sum(mushroom_train4(:,4) == char('t'));
pf4 = yesf4/sum(mushroom_train4(:,4) == char('f'));

yesa5 = 0;
yesl5 = 0;
yesc5 = 0;
yesy5 = 0;
yesf5 = 0;
yesm5 = 0;
yesn5 = 0;
yesp5 = 0;
yess5 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,5) == char('a')
            yesa5 = yesa5 + 1;
        elseif mushroom_train4(i,5) == char('l')
            yesl5 = yesl5 + 1;
        elseif mushroom_train4(i,5) == char('c')
            yesc5 = yesc5 + 1;
        elseif mushroom_train4(i,5) == char('y')
            yesy5 = yesy5 + 1;
        elseif mushroom_train4(i,5) == char('f')
            yesf5 = yesf5 + 1;
        elseif mushroom_train4(i,5) == char('m')
            yesm5 = yesm5 + 1;
        elseif mushroom_train4(i,5) == char('n')
            yesn5 = yesn5 + 1;
        elseif mushroom_train4(i,5) == char('p')
            yesp5 = yesp5 + 1;
        elseif mushroom_train4(i,5) == char('s')
            yess5 = yess5 + 1;
        end
    end
end
pa5 = yesa5/sum(mushroom_train4(:,5) == char('a'));
pl5 = yesl5/sum(mushroom_train4(:,5) == char('l'));
pc5 = yesc5/sum(mushroom_train4(:,5) == char('c'));
py5 = yesy5/sum(mushroom_train4(:,5) == char('y'));
pf5 = yesf5/sum(mushroom_train4(:,5) == char('f'));
pm5 = yesm5/sum(mushroom_train4(:,5) == char('m'));
pn5 = yesn5/sum(mushroom_train4(:,5) == char('n'));
pp5 = yesp5/sum(mushroom_train4(:,5) == char('p'));
ps5 = yess5/sum(mushroom_train4(:,5) == char('s'));

yesa6 = 0;
yesd6 = 0;
yesf6 = 0;
yesn6 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,6) == char('a')
            yesa6 = yesa6 + 1;
        elseif mushroom_train4(i,6) == char('d')
            yesd6 = yesd6 + 1;
        elseif mushroom_train4(i,6) == char('f')
            yesf6 = yesf6 + 1;
        elseif mushroom_train4(i,6) == char('n')
            yesn6 = yesn6 + 1;
        end
    end
end
pa6 = yesa6/sum(mushroom_train4(:,6) == char('a'));
pd6 = yesd6/sum(mushroom_train4(:,6) == char('d'));
pf6 = yesf6/sum(mushroom_train4(:,6) == char('f'));
pn6 = yesn6/sum(mushroom_train4(:,6) == char('n'));

yesc7 = 0;
yesw7 = 0;
yesd7 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,7) == char('c')
            yesc7 = yesc7 + 1;
        elseif mushroom_train4(i,7) == char('w')
            yesw7 = yesw7 + 1;
        elseif mushroom_train4(i,7) == char('d')
            yesd7 = yesd7 + 1;
        end
    end
end
pc7 = yesc7/sum(mushroom_train4(:,7) == char('c'));
pw7 = yesw7/sum(mushroom_train4(:,7) == char('w'));
pd7 = yesd7/sum(mushroom_train4(:,7) == char('d'));

yesb8 = 0;
yesn8 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,8) == char('b')
            yesb8 = yesb8 + 1;
        elseif mushroom_train4(i,8) == char('n')
            yesn8 = yesn8 + 1;
        end
    end
end
pb8 = yesb8/sum(mushroom_train4(:,8) == char('b'));
pn8 = yesn8/sum(mushroom_train4(:,8) == char('n'));

yesk9 = 0;
yesn9 = 0;
yesb9 = 0;
yesh9 = 0;
yesg9 = 0;
yesr9 = 0;
yeso9 = 0;
yesp9 = 0;
yesu9 = 0;
yese9 = 0;
yesw9 = 0;
yesy9 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,9) == char('k')
            yesk9 = yesk9 + 1;
        elseif mushroom_train4(i,9) == char('n')
            yesn9 = yesn9 + 1;
        elseif mushroom_train4(i,9) == char('b')
            yesb9 = yesb9 + 1;
        elseif mushroom_train4(i,9) == char('h')
            yesh9 = yesh9 + 1;
        elseif mushroom_train4(i,9) == char('g')
            yesg9 = yesg9 + 1;
        elseif mushroom_train4(i,9) == char('r')
            yesr9 = yesr9 + 1;
        elseif mushroom_train4(i,9) == char('o')
            yeso9 = yeso9 + 1;
        elseif mushroom_train4(i,9) == char('p')
            yesp9 = yesp9 + 1;
        elseif mushroom_train4(i,9) == char('u')
            yesu9 = yesu9 + 1;
        elseif mushroom_train4(i,9) == char('e')
            yese9 = yese9 + 1;
        elseif mushroom_train4(i,9) == char('w')
            yesw9 = yesw9 + 1;
        elseif mushroom_train4(i,9) == char('y')
            yesy9 = yesy9 + 1;
        end
    end
end
pk9 = yesk9/sum(mushroom_train4(:,9) == char('k'));
pn9 = yesn9/sum(mushroom_train4(:,9) == char('n'));
pb9 = yesb9/sum(mushroom_train4(:,9) == char('b'));
ph9 = yesh9/sum(mushroom_train4(:,9) == char('h'));
pg9 = yesg9/sum(mushroom_train4(:,9) == char('g'));
pr9 = yesr9/sum(mushroom_train4(:,9) == char('r'));
po9 = yeso9/sum(mushroom_train4(:,9) == char('o'));
pp9 = yesp9/sum(mushroom_train4(:,9) == char('p'));
pu9 = yesu9/sum(mushroom_train4(:,9) == char('u'));
pe9 = yese9/sum(mushroom_train4(:,9) == char('e'));
pw9 = yesw9/sum(mushroom_train4(:,9) == char('w'));
py9 = yesy9/sum(mushroom_train4(:,9) == char('y'));

yese10 = 0;
yest10 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,10) == char('e')
            yese10 = yese10 + 1;
        elseif mushroom_train4(i,10) == char('t')
            yest10 = yest10 + 1;
        end
    end
end
pe10 = yese10/sum(mushroom_train4(:,10) == char('e'));
pt10 = yest10/sum(mushroom_train4(:,10) == char('t'));

yesb11 = 0;
yesc11 = 0;
yesu11 = 0;
yese11 = 0;
yesz11 = 0;
yesr11 = 0;
yesmiss11 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,11) == char('b')
            yesb11 = yesb11 + 1;
        elseif mushroom_train4(i,11) == char('c')
            yesc11 = yesc11 + 1;
        elseif mushroom_train4(i,11) == char('u')
            yesu11 = yesu11 + 1;
        elseif mushroom_train4(i,11) == char('e')
            yese11 = yese11 + 1;
        elseif mushroom_train4(i,11) == char('z')
            yesz11 = yesz11 + 1;
        elseif mushroom_train4(i,11) == char('r')
            yesr11 = yesr11 + 1;
        elseif mushroom_train4(i,11) == char('?')
            yesmiss11 = yesmiss11 + 1;
        end
    end
end
pb11 = yesb11/sum(mushroom_train4(:,11) == char('b'));
pc11 = yesc11/sum(mushroom_train4(:,11) == char('c'));
pu11 = yesu11/sum(mushroom_train4(:,11) == char('u'));
pe11 = yese11/sum(mushroom_train4(:,11) == char('e'));
pz11 = yesz11/sum(mushroom_train4(:,11) == char('z'));
pr11 = yesr11/sum(mushroom_train4(:,11) == char('r'));
pmiss11 = yesmiss11/sum(mushroom_train4(:,11) == char('?'));

yesf12 = 0;
yesy12 = 0;
yesk12 = 0;
yess12 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,12) == char('f')
            yesf12 = yesf12 + 1;
        elseif mushroom_train4(i,12) == char('y')
            yesy12 = yesy12 + 1;
        elseif mushroom_train4(i,12) == char('k')
            yesk12 = yesk12 + 1;
        elseif mushroom_train4(i,12) == char('s')
            yess12 = yess12 + 1;
        end
    end
end
pf12 = yesf12/sum(mushroom_train4(:,12) == char('f'));
py12 = yesy12/sum(mushroom_train4(:,12) == char('y'));
pk12 = yesk12/sum(mushroom_train4(:,12) == char('k'));
ps12 = yess12/sum(mushroom_train4(:,12) == char('s'));

yesf13 = 0;
yesy13 = 0;
yesk13 = 0;
yess13 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,13) == char('f')
            yesf13 = yesf13 + 1;
        elseif mushroom_train4(i,13) == char('y')
            yesy13 = yesy13 + 1;
        elseif mushroom_train4(i,13) == char('k')
            yesk13 = yesk13 + 1;
        elseif mushroom_train4(i,13) == char('s')
            yess13 = yess13 + 1;
        end
    end
end
pf13 = yesf13/sum(mushroom_train4(:,13) == char('f'));
py13 = yesy13/sum(mushroom_train4(:,13) == char('y'));
pk13 = yesk13/sum(mushroom_train4(:,13) == char('k'));
ps13 = yess13/sum(mushroom_train4(:,13) == char('s'));

yesn14 = 0;
yesb14 = 0;
yesc14 = 0;
yesg14 = 0;
yeso14 = 0;
yesp14 = 0;
yese14 = 0;
yesw14 = 0;
yesy14 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,14) == char('n')
            yesn14 = yesn14 + 1;
        elseif mushroom_train4(i,14) == char('b')
            yesb14 = yesb14 + 1;
        elseif mushroom_train4(i,14) == char('c')
            yesc14 = yesc14 + 1;
        elseif mushroom_train4(i,14) == char('g')
            yesg14 = yesg14 + 1;
        elseif mushroom_train4(i,14) == char('o')
            yeso14 = yeso14 + 1;
        elseif mushroom_train4(i,14) == char('p')
            yesp14 = yesp14 + 1;
        elseif mushroom_train4(i,14) == char('e')
            yese14 = yese14 + 1;
        elseif mushroom_train4(i,14) == char('w')
            yesw14 = yesw14 + 1;
        elseif mushroom_train4(i,14) == char('y')
            yesy14 = yesy14 + 1;
        end
    end
end
pn14 = yesn14/sum(mushroom_train4(:,14) == char('n'));
pb14 = yesb14/sum(mushroom_train4(:,14) == char('b'));
pc14 = yesc14/sum(mushroom_train4(:,14) == char('c'));
pg14 = yesg14/sum(mushroom_train4(:,14) == char('g'));
po14 = yeso14/sum(mushroom_train4(:,14) == char('o'));
pp14 = yesp14/sum(mushroom_train4(:,14) == char('p'));
pe14 = yese14/sum(mushroom_train4(:,14) == char('e'));
pw14 = yesw14/sum(mushroom_train4(:,14) == char('w'));
py14 = yesy14/sum(mushroom_train4(:,14) == char('y'));

yesn15 = 0;
yesb15 = 0;
yesc15 = 0;
yesg15 = 0;
yeso15 = 0;
yesp15 = 0;
yese15 = 0;
yesw15 = 0;
yesy15 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,15) == char('n')
            yesn15 = yesn15 + 1;
        elseif mushroom_train4(i,15) == char('b')
            yesb15 = yesb15 + 1;
        elseif mushroom_train4(i,15) == char('c')
            yesc15 = yesc15 + 1;
        elseif mushroom_train4(i,15) == char('g')
            yesg15 = yesg15 + 1;
        elseif mushroom_train4(i,15) == char('o')
            yeso15 = yeso15 + 1;
        elseif mushroom_train4(i,15) == char('p')
            yesp15 = yesp15 + 1;
        elseif mushroom_train4(i,15) == char('e')
            yese15 = yese15 + 1;
        elseif mushroom_train4(i,15) == char('w')
            yesw15 = yesw15 + 1;
        elseif mushroom_train4(i,15) == char('y')
            yesy15 = yesy15 + 1;
        end
    end
end
pn15 = yesn15/sum(mushroom_train4(:,15) == char('n'));
pb15 = yesb15/sum(mushroom_train4(:,15) == char('b'));
pc15 = yesc15/sum(mushroom_train4(:,15) == char('c'));
pg15 = yesg15/sum(mushroom_train4(:,15) == char('g'));
po15 = yeso15/sum(mushroom_train4(:,15) == char('o'));
pp15 = yesp15/sum(mushroom_train4(:,15) == char('p'));
pe15 = yese15/sum(mushroom_train4(:,15) == char('e'));
pw15 = yesw15/sum(mushroom_train4(:,15) == char('w'));
py15 = yesy15/sum(mushroom_train4(:,15) == char('y'));

yesp16 = 0;
yesu16 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,16) == char('p')
            yesp16 = yesp16 + 1;
        elseif mushroom_train4(i,16) == char('u')
            yesu16 = yesu16 + 1;
        end
    end
end
pp16 = yesp16/sum(mushroom_train4(:,16) == char('p'));
pu16 = yesu16/sum(mushroom_train4(:,16) == char('u'));

yesn17 = 0;
yeso17 = 0;
yesw17 = 0;
yesy17 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,17) == char('n')
            yesn17 = yesn17 + 1;
        elseif mushroom_train4(i,17) == char('o')
            yeso17 = yeso17 + 1;
        elseif mushroom_train4(i,17) == char('w')
            yesw17 = yesw17 + 1;
        elseif mushroom_train4(i,17) == char('y')
            yesy17 = yesy17 + 1;
        end
    end
end
pn17 = yesn17/sum(mushroom_train4(:,17) == char('n'));
po17 = yeso17/sum(mushroom_train4(:,17) == char('o'));
pw17 = yesw17/sum(mushroom_train4(:,17) == char('w'));
py17 = yesy17/sum(mushroom_train4(:,17) == char('y'));

yesn18 = 0;
yeso18 = 0;
yest18 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,18) == char('n')
            yesn18 = yesn18 + 1;
        elseif mushroom_train4(i,18) == char('o')
            yeso18 = yeso18 + 1;
        elseif mushroom_train4(i,18) == char('t')
            yest18 = yest18 + 1;
        end
    end
end
pn18 = yesn18/sum(mushroom_train4(:,18) == char('n'));
po18 = yeso18/sum(mushroom_train4(:,18) == char('o'));
pt18 = yest18/sum(mushroom_train4(:,18) == char('t'));

yesc19 = 0;
yese19 = 0;
yesf19 = 0;
yesl19 = 0;
yesn19 = 0;
yesp19 = 0;
yess19 = 0;
yesz19 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,19) == char('c')
            yesc19 = yesc19 + 1;
        elseif mushroom_train4(i,19) == char('e')
            yese19 = yese19 + 1;
        elseif mushroom_train4(i,19) == char('f')
            yesf19 = yesf19 + 1;
        elseif mushroom_train4(i,19) == char('l')
            yesl19 = yesl19 + 1;
        elseif mushroom_train4(i,19) == char('n')
            yesn19 = yesn19 + 1;
        elseif mushroom_train4(i,19) == char('p')
            yesp19 = yesp19 + 1;
        elseif mushroom_train4(i,19) == char('s')
            yess19 = yess19 + 1;
        elseif mushroom_train4(i,19) == char('z')
            yesz19 = yesz19 + 1;
        end
    end
end
pc19 = yesc19/sum(mushroom_train4(:,19) == char('c'));
pe19 = yese19/sum(mushroom_train4(:,19) == char('e'));
pf19 = yesf19/sum(mushroom_train4(:,19) == char('f'));
pl19 = yesl19/sum(mushroom_train4(:,19) == char('l'));
pn19 = yesn19/sum(mushroom_train4(:,19) == char('n'));
pp19 = yesp19/sum(mushroom_train4(:,19) == char('p'));
ps19 = yess19/sum(mushroom_train4(:,19) == char('s'));
pz19 = yesz19/sum(mushroom_train4(:,19) == char('z'));

yesk20 = 0;
yesn20 = 0;
yesb20 = 0;
yesh20 = 0;
yesr20 = 0;
yeso20 = 0;
yesu20 = 0;
yesw20 = 0;
yesy20 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,20) == char('k')
            yesk20 = yesk20 + 1;
        elseif mushroom_train4(i,20) == char('n')
            yesn20 = yesn20 + 1;
        elseif mushroom_train4(i,20) == char('b')
            yesb20 = yesb20 + 1;
        elseif mushroom_train4(i,20) == char('h')
            yesh20 = yesh20 + 1;
        elseif mushroom_train4(i,20) == char('r')
            yesr20 = yesr20 + 1;
        elseif mushroom_train4(i,20) == char('o')
            yeso20 = yeso20 + 1;
        elseif mushroom_train4(i,20) == char('u')
            yesu20 = yesu20 + 1;
        elseif mushroom_train4(i,20) == char('w')
            yesw20 = yesw20 + 1;
        elseif mushroom_train4(i,20) == char('y')
            yesy20 = yesy20 + 1;
        end
    end
end
pk20 = yesk20/sum(mushroom_train4(:,20) == char('k'));
pn20 = yesn20/sum(mushroom_train4(:,20) == char('n'));
pb20 = yesb20/sum(mushroom_train4(:,20) == char('b'));
ph20 = yesh20/sum(mushroom_train4(:,20) == char('h'));
pr20 = yesr20/sum(mushroom_train4(:,20) == char('r'));
po20 = yeso20/sum(mushroom_train4(:,20) == char('o'));
pu20 = yesu20/sum(mushroom_train4(:,20) == char('u'));
pw20 = yesw20/sum(mushroom_train4(:,20) == char('w'));
py20 = yesy20/sum(mushroom_train4(:,20) == char('y'));

yesa21 = 0;
yesc21 = 0;
yesn21 = 0;
yess21 = 0;
yesv21 = 0;
yesy21 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,21) == char('a')
            yesa21 = yesa21 + 1;
        elseif mushroom_train4(i,21) == char('c')
            yesc21 = yesc21 + 1;
        elseif mushroom_train4(i,21) == char('n')
            yesn21 = yesn21 + 1;
        elseif mushroom_train4(i,21) == char('s')
            yess21 = yess21 + 1;
        elseif mushroom_train4(i,21) == char('v')
            yesv21 = yesv21 + 1;
        elseif mushroom_train4(i,21) == char('y')
            yesy21 = yesy21 + 1;
        end
    end
end
pa21 = yesa21/sum(mushroom_train4(:,21) == char('a'));
pc21 = yesc21/sum(mushroom_train4(:,21) == char('c'));
pn21 = yesn21/sum(mushroom_train4(:,21) == char('n'));
ps21 = yess21/sum(mushroom_train4(:,21) == char('s'));
pv21 = yesv21/sum(mushroom_train4(:,21) == char('v'));
py21 = yesy21/sum(mushroom_train4(:,21) == char('y'));

yesg22 = 0;
yesl22 = 0;
yesm22 = 0;
yesp22 = 0;
yesu22 = 0;
yesw22 = 0;
yesd22 = 0;
for i = 1:trainsize
    if mushroom_train4(i,mushroom_column) == 1
        if mushroom_train4(i,22) == char('g')
            yesg22 = yesg22 + 1;
        elseif mushroom_train4(i,22) == char('l')
            yesl22 = yesl22 + 1;
        elseif mushroom_train4(i,22) == char('m')
            yesm22 = yesm22 + 1;
        elseif mushroom_train4(i,22) == char('p')
            yesp22 = yesp22 + 1;
        elseif mushroom_train4(i,22) == char('u')
            yesu22 = yesu22 + 1;
        elseif mushroom_train4(i,22) == char('w')
            yesw22 = yesw22 + 1;
        elseif mushroom_train4(i,22) == char('d')
            yesd22 = yesd22 + 1;
        end
    end
end
pg22 = yesg22/sum(mushroom_train4(:,22) == char('g'));
pl22 = yesl22/sum(mushroom_train4(:,22) == char('l'));
pm22 = yesm22/sum(mushroom_train4(:,22) == char('m'));
pp22 = yesp22/sum(mushroom_train4(:,22) == char('p'));
pu22 = yesu22/sum(mushroom_train4(:,22) == char('u'));
pw22 = yesw22/sum(mushroom_train4(:,22) == char('w'));
pd22 = yesd22/sum(mushroom_train4(:,22) == char('d'));

% determine predict result
for i = 1:testsize
    if mushroom_test4(i,1) == char('b')
        p1 = pb1;
    elseif mushroom_test4(i,1) == char('c')
        p1 = pc1;
    elseif mushroom_test4(i,1) == char('x')
        p1 = px1;
    elseif mushroom_test4(i,1) == char('f')
        p1 = pf1;
    elseif mushroom_test4(i,1) == char('k')
        p1 = pk1;
    elseif mushroom_test4(i,1) == char('s')
        p1 = ps1;
    end
    
    if mushroom_test4(i,2) == char('f')
        p2 = pf2;
    elseif mushroom_test4(i,2) == char('g')
        p2 = pg2;
    elseif mushroom_test4(i,2) == char('y')
        p2 = py2;
    elseif mushroom_test4(i,2) == char('s')
        p2 = ps2;
    end
    
    if mushroom_test4(i,3) == char('n')
        p3 = pn3;
    elseif mushroom_test4(i,3) == char('b')
        p3 = pb3;
    elseif mushroom_test4(i,3) == char('c')
        p3 = pc3;
    elseif mushroom_test4(i,3) == char('g')
        p3 = pg3;
    elseif mushroom_test4(i,3) == char('r')
        p3 = pr3;
    elseif mushroom_test4(i,3) == char('p')
        p3 = pp3;
    elseif mushroom_test4(i,3) == char('u')
        p3 = pu3;
    elseif mushroom_test4(i,3) == char('e')
        p3 = pe3;
    elseif mushroom_test4(i,3) == char('w')
        p3 = pw3;
    elseif mushroom_test4(i,3) == char('y')
        p3 = py3;        
    end
    
    if mushroom_test4(i,4) == char('t')
        p4 = pt4;
    elseif mushroom_test4(i,4) == char('f')
        p4 = pf4;
    end
    
    if mushroom_test4(i,5) == char('a')
        p5 = pa5;
    elseif mushroom_test4(i,5) == char('l')
        p5 = pl5;
    elseif mushroom_test4(i,5) == char('c')
        p5 = pc5;
    elseif mushroom_test4(i,5) == char('y')
        p5 = py5;
    elseif mushroom_test4(i,5) == char('f')
        p5 = pf5;
    elseif mushroom_test4(i,5) == char('m')
        p5 = pm5;
    elseif mushroom_test4(i,5) == char('n')
        p5 = pn5;
    elseif mushroom_test4(i,5) == char('p')
        p5 = pp5;
    elseif mushroom_test4(i,5) == char('s')
        p5 = ps5;      
    end
    
    if mushroom_test4(i,6) == char('a')
        p6 = pa6;
    elseif mushroom_test4(i,6) == char('d')
        p6 = pd6;
    elseif mushroom_test4(i,6) == char('f')
        p6 = pf6;
    elseif mushroom_test4(i,6) == char('n')
        p6 = pn6;        
    end 
    
    if mushroom_test4(i,7) == char('c')
        p7 = pc7;
    elseif mushroom_test4(i,7) == char('w')
        p7 = pw7;
    elseif mushroom_test4(i,7) == char('d')
        p7 = pd7;       
    end    
    
    if mushroom_test4(i,8) == char('b')
        p8 = pb8;
    elseif mushroom_test4(i,8) == char('n')
        p8 = pn8;       
    end     
    
    if mushroom_test4(i,9) == char('k')
        p9 = pk9;
    elseif mushroom_test4(i,9) == char('n')
        p9 = pn9;
    elseif mushroom_test4(i,9) == char('b')
        p9 = pb9;
    elseif mushroom_test4(i,9) == char('h')
        p9 = ph9;
    elseif mushroom_test4(i,9) == char('g')
        p9 = pg9;
    elseif mushroom_test4(i,9) == char('r')
        p9 = pr9;
    elseif mushroom_test4(i,9) == char('o')
        p9 = po9;
    elseif mushroom_test4(i,9) == char('p')
        p9 = pp9;
    elseif mushroom_test4(i,9) == char('u')
        p9 = pu9;
    elseif mushroom_test4(i,9) == char('e')
        p9 = pe9;
    elseif mushroom_test4(i,9) == char('w')
        p9 = pw9;
    elseif mushroom_test4(i,9) == char('y')
        p9 = py9;
    end
    
    if mushroom_test4(i,10) == char('e')
        p10 = pe10;
    elseif mushroom_test4(i,10) == char('t')
        p10 = pt10;       
    end
    
    if mushroom_test4(i,11) == char('b')
        p11 = pb11;
    elseif mushroom_test4(i,11) == char('c')
        p11 = pc11;
    elseif mushroom_test4(i,11) == char('u')
        p11 = pu11;
    elseif mushroom_test4(i,11) == char('e')
        p11 = pe11;
    elseif mushroom_test4(i,11) == char('z')
        p11 = pz11;
    elseif mushroom_test4(i,11) == char('r')
        p11 = pr11;
    elseif mushroom_test4(i,11) == char('?')
        p11 = pmiss11;
    end    
    
    if mushroom_test4(i,12) == char('f')
        p12 = pf12;
    elseif mushroom_test4(i,12) == char('y')
        p12 = py12;
    elseif mushroom_test4(i,12) == char('k')
        p12 = pk12;
    elseif mushroom_test4(i,12) == char('s')
        p12 = ps12;
    end
    
    if mushroom_test4(i,13) == char('f')
        p13 = pf13;
    elseif mushroom_test4(i,13) == char('y')
        p13 = py13;
    elseif mushroom_test4(i,13) == char('k')
        p13 = pk13;
    elseif mushroom_test4(i,13) == char('s')
        p13 = ps13;
    end
    
    if mushroom_test4(i,14) == char('n')
        p14 = pn14;
    elseif mushroom_test4(i,14) == char('b')
        p14 = pb14;
    elseif mushroom_test4(i,14) == char('c')
        p14 = pc14;
    elseif mushroom_test4(i,14) == char('g')
        p14 = pg14;
    elseif mushroom_test4(i,14) == char('o')
        p14 = po14;
    elseif mushroom_test4(i,14) == char('p')
        p14 = pp14;
    elseif mushroom_test4(i,14) == char('e')
        p14 = pe14;
    elseif mushroom_test4(i,14) == char('w')
        p14 = pw14;
    elseif mushroom_test4(i,14) == char('y')
        p14 = py14;
    end   
    
    if mushroom_test4(i,15) == char('n')
        p15 = pn15;
    elseif mushroom_test4(i,15) == char('b')
        p15 = pb15;
    elseif mushroom_test4(i,15) == char('c')
        p15 = pc15;
    elseif mushroom_test4(i,15) == char('g')
        p15 = pg15;
    elseif mushroom_test4(i,15) == char('o')
        p15 = po15;
    elseif mushroom_test4(i,15) == char('p')
        p15 = pp15;
    elseif mushroom_test4(i,15) == char('e')
        p15 = pe15;
    elseif mushroom_test4(i,15) == char('w')
        p15 = pw15;
    elseif mushroom_test4(i,15) == char('y')
        p15 = py15;
    end  
    
    if mushroom_test4(i,16) == char('p')
        p16 = pp16;
    elseif mushroom_test4(i,16) == char('u')
        p16 = pu16;
    end
    
    if mushroom_test4(i,17) == char('n')
        p17 = pn17;
    elseif mushroom_test4(i,17) == char('o')
        p17 = po17;
    elseif mushroom_test4(i,17) == char('w')
        p17 = pw17;
    elseif mushroom_test4(i,17) == char('y')
        p17 = py17;
    end    
    
    if mushroom_test4(i,18) == char('n')
        p18 = pn18;
    elseif mushroom_test4(i,18) == char('o')
        p18 = po18;
    elseif mushroom_test4(i,18) == char('t')
        p18 = pt18;
    end   
    
    if mushroom_test4(i,19) == char('c')
        p19 = pc19;
    elseif mushroom_test4(i,19) == char('e')
        p19 = pe19;
    elseif mushroom_test4(i,19) == char('f')
        p19 = pf19;
    elseif mushroom_test4(i,19) == char('l')
        p19 = pl19;
    elseif mushroom_test4(i,19) == char('n')
        p19 = pn19;
    elseif mushroom_test4(i,19) == char('p')
        p19 = pp19;
    elseif mushroom_test4(i,19) == char('s')
        p19 = ps19;
    elseif mushroom_test4(i,19) == char('z')
        p19 = pz19;
    end 
    
    if mushroom_test4(i,20) == char('k')
        p20 = pk20;
    elseif mushroom_test4(i,20) == char('n')
        p20 = pn20;
    elseif mushroom_test4(i,20) == char('b')
        p20 = pb20;
    elseif mushroom_test4(i,20) == char('h')
        p20 = ph20;
    elseif mushroom_test4(i,20) == char('r')
        p20 = pr20;
    elseif mushroom_test4(i,20) == char('o')
        p20 = po20;
    elseif mushroom_test4(i,20) == char('u')
        p20 = pu20;
    elseif mushroom_test4(i,20) == char('w')
        p20 = pw20;
    elseif mushroom_test4(i,20) == char('y')
        p20 = py20;
    end   
        
    if mushroom_test4(i,21) == char('a')
        p21 = pa21;
    elseif mushroom_test4(i,21) == char('c')
        p21 = pc21;
    elseif mushroom_test4(i,21) == char('n')
        p21 = pn21;
    elseif mushroom_test4(i,21) == char('s')
        p21 = ps21;
    elseif mushroom_test4(i,21) == char('v')
        p21 = pv21;
    elseif mushroom_test4(i,21) == char('y')
        p21 = py21;
    end 
        
    if mushroom_test4(i,22) == char('g')
        p22 = pg22;
    elseif mushroom_test4(i,22) == char('l')
        p22 = pl22;
    elseif mushroom_test4(i,22) == char('m')
        p22 = pm22;
    elseif mushroom_test4(i,22) == char('p')
        p22 = pp22;
    elseif mushroom_test4(i,22) == char('u')
        p22 = pu22;
    elseif mushroom_test4(i,22) == char('w')
        p22 = pw22;
    elseif mushroom_test4(i,22) == char('d')
        p22 = pd22;        
    end    
    
    pos = p1*p2*p3*p4*p5*p6*p7*p8*p9*p10*p11*p12*p13*p14*p15*p16*p17*p18*p19*p20*p21*p22;
    neg = (1-p1)*(1-p2)*(1-p3)*(1-p4)*(1-p5)*(1-p6)*(1-p7)*(1-p8)*(1-p9)*(1-p10)*(1-p11)*(1-p12)*(1-p13)*(1-p14)*(1-p15)*(1-p16)*(1-p17)*(1-p18)*(1-p19)*(1-p20)*(1-p21)*(1-p22);    
    if pos >= neg
        FED(i) = 1;
    else
        FED(i) = 0;
    end
end

% get classification rate
for i = 1:testsize
        if FED(i) == mushroom_test4(i,mushroom_column)
           rt = rt + 1;
        end
end
cr = rt/testsize;




        